<template>
    <div>
        <div class="container-fluid">
            <div class="card mt-5">
                <div class="card-header">
                    <span style="font-size: 20px;">Habeas data</span>
                </div>
                <div class="card-body">
                  <div class="row">
                    <a-button type="primary" class="ml-auto m-2 " @click="showModal">Generar Reporte</a-button>
                    <a-modal
                      title="Exportar Excel"
                      id="excel"
                      :visible="visible"
                      @ok="handleOk"
                      :confirmLoading="confirmLoading"
                      @cancel="handleCancel"
                      okText="Descargar">
                      
                      <div class="row">
                        <div class="col-md-12">
                           <div class="form-group row">
                              <label for="date" class="col-sm-3 col-form-label">Fecha</label>
                              <div class="col-sm-9">
                                  <a-range-picker v-model="filters.date" :placeholder="['Fecha Inicio','Fecha Fin']" @change="onChange" />
                              </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                           <div class="form-group row">
                              <label for="inputPassword" class="col-sm-3 col-form-label">Email</label>
                              <div class="col-sm-9">
                              <a-auto-complete @select="onSelect" v-model="filters.email"  style="width: 100%" @search="searchUser" placeholder='Email'>
                                <template  slot="dataSource">
                                  <a-select-option v-for="(user) in resultUsers" type="user" :key="user.email" :obj="user" >{{user.email}}</a-select-option>
                                </template>
                              </a-auto-complete>
                              </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                           <div class="form-group row">
                              <label  class="col-sm-3 col-form-label">Permiso</label>
                              <div class="col-sm-9">
                                <a-select v-model="filters.type" style="width:100%">
                                  <a-select-option value="" >Seleccione</a-select-option>
                                  <a-select-option v-for="type in types" :key="type" >{{type}}</a-select-option>
                                </a-select>
                              </div>
                            </div>
                        </div>

                        <div class="col-md-12">
                           <div class="form-group row">
                              <label for="value" class="col-sm-3 col-form-label">Acepto</label>
                              <div class="col-sm-9">
                                <a-radio-group v-model="filters.value" buttonStyle="solid">
                                  <a-radio-button value="si">Si</a-radio-button>
                                  <a-radio-button value="no">No</a-radio-button>
                                  <a-radio-button :value="null">Ambos</a-radio-button>
                                </a-radio-group>
                                
                              </div>
                            </div>
                        </div>
                      </div>
                    </a-modal>
                  </div>

                    <div class="col-md-12 px-0 py-0">
                        <div>
                            <a-table 
                            :columns="columns" 
                            :dataSource="data" 
                            :rowKey="record => record.id" 
                            :pagination="pagination"
                            :rowSelection="{onChange: onSelectChange}"
                            @change="handleTableChange"
                            :loading="loading" >
                                <span slot="action" slot-scope="text, record">
                                  <p v-if="record.value">Si</p>
                                  <p v-else>No</p>
                                </span>
                                <span slot="user_name" slot-scope="text, record">
                                  {{record.user.id}} - {{record.user.name}}
                                </span>
                                <span slot="action3" slot-scope="text, record">
                                  {{record.updated_at}}
                                </span>
                            </a-table>
                            <a-button type="primary" class="btn btn-success  rounded btn-sm m-2"  v-if="selectedRowsKey.length==0" :disabled="true">Exportar</a-button>
                            <a-button type="primary" class="btn btn-success  rounded btn-sm m-2"  :href="'admin/export/habeas-data/selected?'+params2"  v-if="selectedRowsKey.length>0">Exportar</a-button>

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import { type } from 'os';
export default {
  data() {
    return {
        visible: false,
        confirmLoading: false,
        filters: {
          type: "",
          value: null,
          date: null,
          email: null
        },
        types:[
          'Terminos',
           'Informacion comercial'],
        resultUsers: [],
        data: [],
        pagination:{},
        loading: false,
        selectedRowsKey: [],
        columns: [
        { title: "Email", dataIndex: "email", key: "email" },
        { title: "Permiso", dataIndex: "type", key: "type",
         
        },
        {
          title: "Acepto",
          key: "action",
          scopedSlots: { customRender: "action" }
        },
        { title: "Direccion IP", dataIndex: "ip_address", key: "ip_address" },
        { title: "Fecha",  scopedSlots: { customRender: "action3" }, key: "action3" },
        {
          title: "Usuario",
          key: "user_id",
          scopedSlots: { customRender: "user_name" }
        },
        {
          title: "",
          key: "action4",
          scopedSlots: { customRender: "action4" }
        },
        
      ],
    }
  },
  computed: {
    params(){
      const queryString = require('query-string');
      return  queryString.stringify(this.filters, {arrayFormat: 'bracket'});
    },
    
    params2(){
      const queryString = require('query-string');
      return  queryString.stringify(this.selectedRowsKey, {arrayFormat: 'bracket'});
    },
  },
  methods: {
    handleTableChange(pagination) {
      const pager = { ...this.pagination };
      pager.current = pagination.current;
      this.pagination = pager;
      this.fetch({
        //results: pagination.pageSize,
        page: pagination.current,
        
      });
    },
    fetch(params = {}) {
      this.loading = true;
      axios.get("/admin/habeas-data", {params}).then(response => {
        const pagination = { ...this.pagination };
        // Read total count from server
        // pagination.total = data.totalCount;

        pagination.pageSize= response.data.per_page;
        pagination.total = response.data.total;

        this.loading = false;
        this.data = response.data.data;
        this.pagination = pagination;
      });
    },
    handleOk(e) {
      const queryString = require("query-string");
      let info = queryString.stringify(this.filters, {
        arrayFormat: "bracket"
      });
      console.log(info);
      if (this.valid()) {
         window.location.href = "admin/export/habeas-data?" + info;
         this.$message.success("Reporte generado con exito");
      }else{
        this.$message.error("Debe diligenciar al menos un campo");
      }
    },
    showModal() {
      this.visible = true;
    },
    handleCancel(e) {
      this.visible = false;
      this.clearFilters();
    },
    clearFilters(){
      this.filters.type= "",
      this.filters.value= null
      this.filters.email= null
      this.filters.date= null
    },
    onSelectChange(selectedRowsKey) {
      this.selectedRowsKey = selectedRowsKey;
    },
    onSelect(a, option) {
      switch (option.data.attrs.type) {
        case "user":
          this.filters.email = option.data.attrs.obj.email;
          break;

        default:
          break;
      }
    },
    searchUser(value) {
      let _this = this;
      axios.get("/admin/habeas-data/filters/" + value).then(res => {
        _this.resultUsers = res.data;
      });
    },
    onChange(date, dateString) {
      this.filters.date = date;
    },
    valid(){
      let _this = this;
      let val = true

      if (
        this.filters.type == "" &&
        this.filters.value == null &&
        this.filters.date == null &&
        this.filters.email == null) {
        
        val = false
      }
      return val;
    }
  },
  mounted() {
    this.fetch();
  }
};
</script>